clear
close all

%% run herding with the true distribution of a Gaussian mixture model
display('run herding with the true distribution of a Gaussian mixture model');
[obj, X, Y, f] = GMgen;
[S1,err1] = kHerding_sample_GM(obj,1e3,.5);

% Plot
figure
contour(X,Y,f,20);
hold on
plot(S1(1,:),S1(2,:),'rx','LineWidth',2);
hold off

%% run herding with the empirical distribution, i.e. a set of data points
display('run herding with the empirical distribution, i.e. a set of data points');
Srnd = random(obj,1e4)'; % Generate an empirical distribution
[S2,err2] = kHerding_resample(Srnd,1e3,.5);
figure; plot(S2(1,:), S2(2,:), 'x');

% Plot
figure
contour(X,Y,f,20);
hold on
plot(Srnd(1,:),Srnd(2,:),'b+')
plot(S2(1,:),S2(2,:),'rx');
hold off